
#ifndef DAQCONFIGURATOR_H_
#define DAQCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Base_Packet.h>
#include <Base_Protocol.h>
#include <Base_Monitor.h>
#include <Base_Archiver.h>
#include <Base_Provider.h>
#include <Astri_DAQ.h>

namespace inaf::oasbo::DAQ{
class DAQConfigurator : public BaseConfigurator{
private:
	ConnectionProtocols::BaseProtocol * createProtocol(int argc, char ** argv);
	Archivers::BaseArchiver * createArchiver(int argc, char ** argv);
	Providers::BaseProvider * createProvider(int argc, char ** argv);
	PacketMonitors::BasePacketMonitor * createMonitor(int argc, char ** argv);

public:
	DAQConfigurator(int argc, char **argv);
	DAQConfigurator();
	PacketLib::BasePacket * createPacket(int argc, char ** argv); // TBD private and support for different type of packet

	DAQ::AstriDAQ * createDAQFromConf(int argc, char **argv);

	std::map<std::string,std::string> getParams(){return this->params;}

	void printConfiguration(){
		std::string confStr = "Receiver Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}


};
}
#endif
